ALTER TABLE [dbo].[titleauthor] DROP CONSTRAINT FK__titleauth__au_id__164452B1
GO

ALTER TABLE [dbo].[employee] DROP CONSTRAINT FK__employee__job_id__2D27B809
GO

ALTER TABLE [dbo].[employee] DROP CONSTRAINT FK__employee__pub_id__300424B4
GO

ALTER TABLE [dbo].[pub_info] DROP CONSTRAINT FK__pub_info__pub_id__286302EC
GO

ALTER TABLE [dbo].[titles] DROP CONSTRAINT FK__titles__pub_id__1273C1CD
GO

ALTER TABLE [dbo].[discounts] DROP CONSTRAINT FK__discounts__stor___20C1E124
GO

ALTER TABLE [dbo].[sales] DROP CONSTRAINT FK__sales__stor_id__1BFD2C07
GO

ALTER TABLE [dbo].[roysched] DROP CONSTRAINT FK__roysched__title___1ED998B2
GO

ALTER TABLE [dbo].[sales] DROP CONSTRAINT FK__sales__title_id__1CF15040
GO

ALTER TABLE [dbo].[titleauthor] DROP CONSTRAINT FK__titleauth__title__173876EA
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[employee_insupd]') and OBJECTPROPERTY(id, N'IsTrigger') = 1)
drop trigger [dbo].[employee_insupd]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[byroyalty]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[byroyalty]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[reptq2]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[reptq2]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[reptq1]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[reptq1]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[reptq3]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[reptq3]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[titleview]') and OBJECTPROPERTY(id, N'IsView') = 1)
drop view [dbo].[titleview]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[roysched]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[roysched]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[sales]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[sales]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[titleauthor]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[titleauthor]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[pub_info]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[pub_info]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[discounts]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[discounts]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[employee]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[employee]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[titles]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[titles]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[authors]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[authors]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[jobs]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[jobs]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[publishers]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[publishers]
GO

if exists (select * from sysobjects where id = object_id(N'[dbo].[stores]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[stores]
GO

if exists (select * from systypes where name = N'empid')
exec sp_droptype N'empid'
GO

if exists (select * from systypes where name = N'id')
exec sp_droptype N'id'
GO

if exists (select * from systypes where name = N'tid')
exec sp_droptype N'tid'
GO

setuser N'dbo'
GO

EXEC sp_addtype N'empid', N'char (9)', N'not null'
GO

setuser
GO

setuser N'dbo'
GO

EXEC sp_addtype N'id', N'varchar (11)', N'not null'
GO

setuser
GO

setuser N'dbo'
GO

EXEC sp_addtype N'tid', N'varchar (6)', N'not null'
GO

setuser
GO

CREATE TABLE [dbo].[authors] (
	[au_id] [id] NOT NULL ,
	[au_lname] [varchar] (40) NOT NULL ,
	[au_fname] [varchar] (20) NOT NULL ,
	[phone] [char] (12) NOT NULL ,
	[address] [varchar] (40) NULL ,
	[city] [varchar] (20) NULL ,
	[state] [char] (2) NULL ,
	[zip] [char] (5) NULL ,
	[contract] [bit] NOT NULL 
)
GO

CREATE TABLE [dbo].[jobs] (
	[job_id] [smallint] IDENTITY (1, 1) NOT NULL ,
	[job_desc] [varchar] (50) NOT NULL ,
	[min_lvl] [tinyint] NOT NULL ,
	[max_lvl] [tinyint] NOT NULL 
)
GO

CREATE TABLE [dbo].[publishers] (
	[pub_id] [char] (4) NOT NULL ,
	[pub_name] [varchar] (40) NULL ,
	[city] [varchar] (20) NULL ,
	[state] [char] (2) NULL ,
	[country] [varchar] (30) NULL 
)
GO

CREATE TABLE [dbo].[stores] (
	[stor_id] [char] (4) NOT NULL ,
	[stor_name] [varchar] (40) NULL ,
	[stor_address] [varchar] (40) NULL ,
	[city] [varchar] (20) NULL ,
	[state] [char] (2) NULL ,
	[zip] [char] (5) NULL 
)
GO

CREATE TABLE [dbo].[pub_info] (
	[pub_id] [char] (4) NOT NULL ,
	[logo] [image] NULL ,
	[pr_info] [text] NULL 
)
GO

CREATE TABLE [dbo].[discounts] (
	[discounttype] [varchar] (40) NOT NULL ,
	[stor_id] [char] (4) NULL ,
	[lowqty] [smallint] NULL ,
	[highqty] [smallint] NULL ,
	[discount] [decimal](4, 2) NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[employee] (
	[emp_id] [empid] NOT NULL ,
	[fname] [varchar] (20) NOT NULL ,
	[minit] [char] (1) NULL ,
	[lname] [varchar] (30) NOT NULL ,
	[job_id] [smallint] NOT NULL ,
	[job_lvl] [tinyint] NOT NULL ,
	[pub_id] [char] (4) NOT NULL ,
	[hire_date] [datetime] NOT NULL 
)
GO

CREATE TABLE [dbo].[titles] (
	[title_id] [tid] NOT NULL ,
	[title] [varchar] (80) NOT NULL ,
	[type] [char] (12) NOT NULL ,
	[pub_id] [char] (4) NULL ,
	[price] [money] NULL ,
	[advance] [money] NULL ,
	[royalty] [int] NULL ,
	[ytd_sales] [int] NULL ,
	[notes] [varchar] (200) NULL ,
	[pubdate] [datetime] NOT NULL 
)
GO

CREATE TABLE [dbo].[roysched] (
	[title_id] [tid] NOT NULL ,
	[lorange] [int] NULL ,
	[hirange] [int] NULL ,
	[royalty] [int] NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[sales] (
	[stor_id] [char] (4) NOT NULL ,
	[ord_num] [varchar] (20) NOT NULL ,
	[ord_date] [datetime] NOT NULL ,
	[qty] [smallint] NOT NULL ,
	[payterms] [varchar] (12) NOT NULL ,
	[title_id] [tid] NOT NULL 
)
GO

CREATE TABLE [dbo].[titleauthor] (
	[au_id] [id] NOT NULL ,
	[title_id] [tid] NOT NULL ,
	[au_ord] [tinyint] NULL ,
	[royaltyper] [int] NULL 
)
GO

ALTER TABLE [dbo].[authors] WITH NOCHECK ADD 
	CONSTRAINT [UPKCL_auidind] PRIMARY KEY  CLUSTERED 
	(
		[au_id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[jobs] WITH NOCHECK ADD 
	 PRIMARY KEY  CLUSTERED 
	(
		[job_id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[publishers] WITH NOCHECK ADD 
	CONSTRAINT [UPKCL_pubind] PRIMARY KEY  CLUSTERED 
	(
		[pub_id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[stores] WITH NOCHECK ADD 
	CONSTRAINT [UPK_storeid] PRIMARY KEY  CLUSTERED 
	(
		[stor_id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[pub_info] WITH NOCHECK ADD 
	CONSTRAINT [UPKCL_pubinfo] PRIMARY KEY  CLUSTERED 
	(
		[pub_id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[titles] WITH NOCHECK ADD 
	CONSTRAINT [UPKCL_titleidind] PRIMARY KEY  CLUSTERED 
	(
		[title_id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[sales] WITH NOCHECK ADD 
	CONSTRAINT [UPKCL_sales] PRIMARY KEY  CLUSTERED 
	(
		[stor_id],
		[ord_num],
		[title_id]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[titleauthor] WITH NOCHECK ADD 
	CONSTRAINT [UPKCL_taind] PRIMARY KEY  CLUSTERED 
	(
		[au_id],
		[title_id]
	)  ON [PRIMARY] 
GO

 CREATE  CLUSTERED  INDEX [employee_ind] ON [dbo].[employee]([lname], [fname], [minit]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[authors] WITH NOCHECK ADD 
	CONSTRAINT [DF__authors__phone__09DE7BCC] DEFAULT ('UNKNOWN') FOR [phone],
	 CHECK (([au_id] like '[0-9][0-9][0-9]-[0-9][0-9]-[0-9][0-9][0-9][0-9]')),
	 CHECK (([zip] like '[0-9][0-9][0-9][0-9][0-9]'))
GO

ALTER TABLE [dbo].[jobs] WITH NOCHECK ADD 
	CONSTRAINT [DF__jobs__job_desc__239E4DCF] DEFAULT ('New Position - title not formalized yet') FOR [job_desc],
	 CHECK ([max_lvl] <= 250),
	 CHECK ([min_lvl] >= 10)
GO

ALTER TABLE [dbo].[publishers] WITH NOCHECK ADD 
	CONSTRAINT [DF__publisher__count__0EA330E9] DEFAULT ('USA') FOR [country],
	 CHECK ([pub_id] = '1756' or [pub_id] = '1622' or [pub_id] = '0877' or [pub_id] = '0736' or [pub_id] = '1389' or ([pub_id] like '99[0-9][0-9]'))
GO

ALTER TABLE [dbo].[employee] WITH NOCHECK ADD 
	CONSTRAINT [DF__employee__job_id__2C3393D0] DEFAULT (1) FOR [job_id],
	CONSTRAINT [DF__employee__job_lv__2E1BDC42] DEFAULT (10) FOR [job_lvl],
	CONSTRAINT [DF__employee__pub_id__2F10007B] DEFAULT ('9952') FOR [pub_id],
	CONSTRAINT [DF__employee__hire_d__30F848ED] DEFAULT (getdate()) FOR [hire_date],
	CONSTRAINT [PK_emp_id] PRIMARY KEY  NONCLUSTERED 
	(
		[emp_id]
	)  ON [PRIMARY] ,
	CONSTRAINT [CK_emp_id] CHECK (([emp_id] like '[A-Z][A-Z][A-Z][1-9][0-9][0-9][0-9][0-9][FM]') or ([emp_id] like '[A-Z]-[A-Z][1-9][0-9][0-9][0-9][0-9][FM]'))
GO

ALTER TABLE [dbo].[titles] WITH NOCHECK ADD 
	CONSTRAINT [DF__titles__type__117F9D94] DEFAULT ('UNDECIDED') FOR [type],
	CONSTRAINT [DF__titles__pubdate__1367E606] DEFAULT (getdate()) FOR [pubdate]
GO

 CREATE  INDEX [aunmind] ON [dbo].[authors]([au_lname], [au_fname]) ON [PRIMARY]
GO

 CREATE  INDEX [titleind] ON [dbo].[titles]([title]) ON [PRIMARY]
GO

 CREATE  INDEX [titleidind] ON [dbo].[roysched]([title_id]) ON [PRIMARY]
GO

 CREATE  INDEX [titleidind] ON [dbo].[sales]([title_id]) ON [PRIMARY]
GO

 CREATE  INDEX [auidind] ON [dbo].[titleauthor]([au_id]) ON [PRIMARY]
GO

 CREATE  INDEX [titleidind] ON [dbo].[titleauthor]([title_id]) ON [PRIMARY]
GO

ALTER TABLE [dbo].[pub_info] ADD 
	 FOREIGN KEY 
	(
		[pub_id]
	) REFERENCES [dbo].[publishers] (
		[pub_id]
	)
GO

ALTER TABLE [dbo].[discounts] ADD 
	 FOREIGN KEY 
	(
		[stor_id]
	) REFERENCES [dbo].[stores] (
		[stor_id]
	)
GO

ALTER TABLE [dbo].[employee] ADD 
	 FOREIGN KEY 
	(
		[job_id]
	) REFERENCES [dbo].[jobs] (
		[job_id]
	),
	 FOREIGN KEY 
	(
		[pub_id]
	) REFERENCES [dbo].[publishers] (
		[pub_id]
	)
GO

ALTER TABLE [dbo].[titles] ADD 
	 FOREIGN KEY 
	(
		[pub_id]
	) REFERENCES [dbo].[publishers] (
		[pub_id]
	)
GO

ALTER TABLE [dbo].[roysched] ADD 
	 FOREIGN KEY 
	(
		[title_id]
	) REFERENCES [dbo].[titles] (
		[title_id]
	)
GO

ALTER TABLE [dbo].[sales] ADD 
	 FOREIGN KEY 
	(
		[stor_id]
	) REFERENCES [dbo].[stores] (
		[stor_id]
	),
	 FOREIGN KEY 
	(
		[title_id]
	) REFERENCES [dbo].[titles] (
		[title_id]
	)
GO

ALTER TABLE [dbo].[titleauthor] ADD 
	 FOREIGN KEY 
	(
		[au_id]
	) REFERENCES [dbo].[authors] (
		[au_id]
	),
	 FOREIGN KEY 
	(
		[title_id]
	) REFERENCES [dbo].[titles] (
		[title_id]
	)
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO


CREATE VIEW titleview
AS
select title, au_ord, au_lname, price, ytd_sales, pub_id
from authors, titles, titleauthor
where authors.au_id = titleauthor.au_id
   AND titles.title_id = titleauthor.title_id


GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO


CREATE PROCEDURE reptq1 AS
select pub_id, title_id, price, pubdate
from titles
where price is NOT NULL
order by pub_id
COMPUTE avg(price) BY pub_id
COMPUTE avg(price)


GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO


CREATE PROCEDURE reptq3 @lolimit money, @hilimit money,
@type char(12)
AS
select pub_id, type, title_id, price
from titles
where price >@lolimit AND price <@hilimit AND type = @type OR type LIKE '%cook%'
order by pub_id, type
COMPUTE count(title_id) BY pub_id, type


GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO


CREATE PROCEDURE byroyalty @percentage int
AS
select au_id from titleauthor
where titleauthor.royaltyper = @percentage


GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO


CREATE PROCEDURE reptq2 AS
select type, pub_id, titles.title_id, au_ord,
   Name = substring (au_lname, 1,15), ytd_sales
from titles, authors, titleauthor
where titles.title_id = titleauthor.title_id AND authors.au_id = titleauthor.au_id
   AND pub_id is NOT NULL
order by pub_id, type
COMPUTE avg(ytd_sales) BY pub_id, type
COMPUTE avg(ytd_sales) BY pub_id


GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  OFF 
GO


CREATE TRIGGER employee_insupd
ON employee
FOR insert, UPDATE
AS
--Get the range of level for this job type from the jobs table.
declare @min_lvl tinyint,
   @max_lvl tinyint,
   @emp_lvl tinyint,
   @job_id smallint
select @min_lvl = min_lvl,
   @max_lvl = max_lvl,
   @emp_lvl = i.job_lvl,
   @job_id = i.job_id
from employee e, jobs j, inserted i
where e.emp_id = i.emp_id AND i.job_id = j.job_id
IF (@job_id = 1) and (@emp_lvl <> 10)
begin
   raiserror ('Job id 1 expects the default level of 10.',16,1)
   ROLLBACK TRANSACTION
end
ELSE
IF NOT (@emp_lvl BETWEEN @min_lvl AND @max_lvl)
begin
   raiserror ('The level for job_id:%d should be between %d and %d.',
      16, 1, @job_id, @min_lvl, @max_lvl)
   ROLLBACK TRANSACTION
end


GO
SET QUOTED_IDENTIFIER  OFF    SET ANSI_NULLS  ON 
GO

